<script lang="ts">
import type { ChordDefinition } from "@/lib/chordDictionary";
import { defineComponent } from "vue";
import ChordPositions from "./ChordPositions.vue";
import ChordFretboard from "./ChordFretboard.vue";

const chordDef: ChordDefinition = [
  [0, 6, 0, 0, 9],
  [1, 0, 5, 0, 0],
  [2, 0, 0, 7, 0],
];

const initialChordDef: ChordDefinition = [
  [0, 8, 0, 0, 9],
  [1, 0, 8, 0, 0],
  [2, 0, 0, 8, 0],
];

export default defineComponent({
  components: {
    ChordPositions,
    ChordFretboard,
  },
  mounted() {
    this.$refs.chordPositions.reset();
    setTimeout(() => {
      this.$refs.chordPositions.revealQuickly(initialChordDef, () => {
        setTimeout(() => {
          this.$refs.chordPositions.revealGuess(chordDef, () => {
            if (this.$refs.chordPositions) {
              this.$refs.chordPositions.doRipple(() => null);
            }
          });
        }, 1000);
      });
    }, 1000);
  },
  data() {
    return {
      initialChordDef,
      chordDef,
    };
  },
  props: {
    correctGuessText: { type: String, required: true },
    closeGuessText: { type: String, required: true },
  },
});
</script>
<template>
  <div class="help">
    <h1 class="title">
      <div class="howto">How to Play</div>
      <i class="close fa-solid fa-xmark fa-lg" @click="$emit('onClose')"></i>
    </h1>

    <p>Guess the <strong>Ukordle </strong>in five tries.</p>
    <p>
      Each guess must be a valid ukulele chord. Hit the enter button to submit.
    </p>

    <p>
      After each guess, the color of the fretted positions will change to show
      how close your guess was to the chord.
    </p>

    <div class="example">
      <p class="bold">Example</p>

      <svg style="height: 12em; width: 9em" viewBox="0, 8, 75, 120">
        <ChordFretboard :startFret="0" />
        <ChordPositions :initialStartFret="0" ref="chordPositions" />
      </svg>

      <p>
        The <strong class="correct_guess">{{ correctGuessText }}</strong> guess
        is both a correct note on the correct string and fret.<br />
        The <strong class="close_guess">{{ closeGuessText }}</strong> guess is
        the correct note but incorrect string and fret.<br />
        The <strong class="grey">grey</strong> guess is not in the chord on any
        string or fret.<br />
        The <strong class="grey">×</strong> guesses that this string is not
        played. No hint is given as to whether this is correct or not.<br />
      </p>

      <p class="bold">
        A new <strong>Ukordle</strong> will be available each day!
      </p>
    </div>

    <p class="info">Please note this site uses cookies</p>

    <p class="info">
      <a href="mailto:admin@ukejam.online" style="color: black"
        ><i class="fa-solid fa-envelope"></i
      ></a>
    </p>
  </div>
</template>
<style scoped>
.help {
  max-width: 468px;
  margin: 0 auto;
  padding: 0 1em;
  font-size: 14px;
  font-family: "Clear Sans", "Helvetica Neue", Arial, sans-serif;
}

.title {
  font-size: 16px;
  margin: 1em 0 1.2em;
  text-transform: uppercase;
  text-align: center;
  padding: 0;
}

.info {
  margin-top: 1em;
  font-style: italic;
  color: #787c7e;
  text-align: center;
}

.example {
  border-top: 1px solid #d3d6da;
  border-bottom: 1px solid #d3d6da;
}
.bold {
  font-weight: bold;
}

strong {
  text-transform: uppercase;
}

.correct_guess {
  color: var(--correct);
}

.close_guess {
  color: var(--close);
}

.grey {
  color: var(--secondary);
}

.howto {
}

.close {
  float: right;
  margin-top: -9px;
  cursor: pointer;
}
</style>
